<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.14"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>iipsrv: IIPImage Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="iip.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">iipsrv
   &#160;<span id="projectnumber">1.1</span>
   </div>
   <div id="projectbrief">iipsrv is an advanced high-performance feature-rich image server for web-based streamed viewing and zooming of ultra high-resolution images</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.14 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('classIIPImage.html','');});
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classIIPImage-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">IIPImage Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Main class to handle the pyramidal image source.  
 <a href="classIIPImage.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="IIPImage_8h_source.html">IIPImage.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for IIPImage:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classIIPImage.png" usemap="#IIPImage_map" alt=""/>
  <map id="IIPImage_map" name="IIPImage_map">
<area href="classKakaduImage.html" title="Image class for Kakadu JPEG2000 Images: Inherits from IIPImage. Uses the Kakadu library. " alt="KakaduImage" shape="rect" coords="0,56,108,80"/>
<area href="classOpenJPEGImage.html" alt="OpenJPEGImage" shape="rect" coords="118,56,226,80"/>
<area href="classTPTImage.html" title="Image class for Tiled Pyramidal Images: Inherits from IIPImage. Uses libtiff. " alt="TPTImage" shape="rect" coords="236,56,344,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a06badd6d06107fe6110a027eaac7318c"><td class="memItemLeft" align="right" valign="top"><a id="a06badd6d06107fe6110a027eaac7318c"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a06badd6d06107fe6110a027eaac7318c">IIPImage</a> ()</td></tr>
<tr class="memdesc:a06badd6d06107fe6110a027eaac7318c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Default Constructor. <br /></td></tr>
<tr class="separator:a06badd6d06107fe6110a027eaac7318c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b06782b2f2d63ca75e915762356b638"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a0b06782b2f2d63ca75e915762356b638">IIPImage</a> (const std::string &amp;s)</td></tr>
<tr class="memdesc:a0b06782b2f2d63ca75e915762356b638"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructer taking the image path as parameter.  <a href="#a0b06782b2f2d63ca75e915762356b638">More...</a><br /></td></tr>
<tr class="separator:a0b06782b2f2d63ca75e915762356b638"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a315b290529ed48af287008cb88de5d78"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a315b290529ed48af287008cb88de5d78">IIPImage</a> (const <a class="el" href="classIIPImage.html">IIPImage</a> &amp;image)</td></tr>
<tr class="memdesc:a315b290529ed48af287008cb88de5d78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy Constructor taking reference to another <a class="el" href="classIIPImage.html" title="Main class to handle the pyramidal image source. ">IIPImage</a> object.  <a href="#a315b290529ed48af287008cb88de5d78">More...</a><br /></td></tr>
<tr class="separator:a315b290529ed48af287008cb88de5d78"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3713fd838842aabaa1b2ed306b1149de"><td class="memItemLeft" align="right" valign="top"><a id="a3713fd838842aabaa1b2ed306b1149de"></a>
virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a3713fd838842aabaa1b2ed306b1149de">~IIPImage</a> ()</td></tr>
<tr class="memdesc:a3713fd838842aabaa1b2ed306b1149de"><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual Destructor. <br /></td></tr>
<tr class="separator:a3713fd838842aabaa1b2ed306b1149de"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac37a85dae89ab056872b9bb574459a76"><td class="memItemLeft" align="right" valign="top"><a id="ac37a85dae89ab056872b9bb574459a76"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ac37a85dae89ab056872b9bb574459a76">Initialise</a> ()</td></tr>
<tr class="memdesc:ac37a85dae89ab056872b9bb574459a76"><td class="mdescLeft">&#160;</td><td class="mdescRight">Test the image and initialise some parameters. <br /></td></tr>
<tr class="separator:ac37a85dae89ab056872b9bb574459a76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ad4382ddbf025261049257bcfbf0f23"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a1ad4382ddbf025261049257bcfbf0f23">swap</a> (<a class="el" href="classIIPImage.html">IIPImage</a> &amp;a, <a class="el" href="classIIPImage.html">IIPImage</a> &amp;b)</td></tr>
<tr class="memdesc:a1ad4382ddbf025261049257bcfbf0f23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Swap function.  <a href="#a1ad4382ddbf025261049257bcfbf0f23">More...</a><br /></td></tr>
<tr class="separator:a1ad4382ddbf025261049257bcfbf0f23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad55747906896868279c8d14adc3d7304"><td class="memItemLeft" align="right" valign="top"><a id="ad55747906896868279c8d14adc3d7304"></a>
std::list&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ad55747906896868279c8d14adc3d7304">getVerticalViewsList</a> ()</td></tr>
<tr class="memdesc:ad55747906896868279c8d14adc3d7304"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a list of available vertical angles. <br /></td></tr>
<tr class="separator:ad55747906896868279c8d14adc3d7304"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd23c9da4bc24eed7a6791d1cec3e28f"><td class="memItemLeft" align="right" valign="top"><a id="afd23c9da4bc24eed7a6791d1cec3e28f"></a>
std::list&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#afd23c9da4bc24eed7a6791d1cec3e28f">getHorizontalViewsList</a> ()</td></tr>
<tr class="memdesc:afd23c9da4bc24eed7a6791d1cec3e28f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a list of horizontal angles. <br /></td></tr>
<tr class="separator:afd23c9da4bc24eed7a6791d1cec3e28f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c2bc5062ad70e66073c6b8e7cf0eb33"><td class="memItemLeft" align="right" valign="top"><a id="a1c2bc5062ad70e66073c6b8e7cf0eb33"></a>
const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a1c2bc5062ad70e66073c6b8e7cf0eb33">getImagePath</a> ()</td></tr>
<tr class="memdesc:a1c2bc5062ad70e66073c6b8e7cf0eb33"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the image path. <br /></td></tr>
<tr class="separator:a1c2bc5062ad70e66073c6b8e7cf0eb33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c1eed40617116d2886772708db5cd18"><td class="memItemLeft" align="right" valign="top">const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a1c1eed40617116d2886772708db5cd18">getFileName</a> (int x, int y)</td></tr>
<tr class="memdesc:a1c1eed40617116d2886772708db5cd18"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the full file path for a particular horizontal and vertical angle.  <a href="#a1c1eed40617116d2886772708db5cd18">More...</a><br /></td></tr>
<tr class="separator:a1c1eed40617116d2886772708db5cd18"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa380533e0bf44f8c01b7812068b00318"><td class="memItemLeft" align="right" valign="top"><a id="aa380533e0bf44f8c01b7812068b00318"></a>
ImageFormat&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aa380533e0bf44f8c01b7812068b00318">getImageFormat</a> ()</td></tr>
<tr class="memdesc:aa380533e0bf44f8c01b7812068b00318"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the image format. <br /></td></tr>
<tr class="separator:aa380533e0bf44f8c01b7812068b00318"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36b0f425868ddbceb401e046fd8d44e3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a36b0f425868ddbceb401e046fd8d44e3">updateTimestamp</a> (const std::string &amp;s)</td></tr>
<tr class="memdesc:a36b0f425868ddbceb401e046fd8d44e3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the image timestamp.  <a href="#a36b0f425868ddbceb401e046fd8d44e3">More...</a><br /></td></tr>
<tr class="separator:a36b0f425868ddbceb401e046fd8d44e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0482c9740d637e3f61f8f80475b3cde5"><td class="memItemLeft" align="right" valign="top"><a id="a0482c9740d637e3f61f8f80475b3cde5"></a>
const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a0482c9740d637e3f61f8f80475b3cde5">getTimestamp</a> ()</td></tr>
<tr class="memdesc:a0482c9740d637e3f61f8f80475b3cde5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a HTTP RFC 1123 formatted timestamp. <br /></td></tr>
<tr class="separator:a0482c9740d637e3f61f8f80475b3cde5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a596986be264c107c4798e48db471acc0"><td class="memItemLeft" align="right" valign="top"><a id="a596986be264c107c4798e48db471acc0"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a596986be264c107c4798e48db471acc0">set</a> ()</td></tr>
<tr class="memdesc:a596986be264c107c4798e48db471acc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check whether this object has been initialised. <br /></td></tr>
<tr class="separator:a596986be264c107c4798e48db471acc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6b7f67a066c9d2f140e02f57eb27eac"><td class="memItemLeft" align="right" valign="top"><a id="ad6b7f67a066c9d2f140e02f57eb27eac"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ad6b7f67a066c9d2f140e02f57eb27eac">setFileSystemPrefix</a> (const std::string &amp;prefix)</td></tr>
<tr class="memdesc:ad6b7f67a066c9d2f140e02f57eb27eac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a file system prefix for added security. <br /></td></tr>
<tr class="separator:ad6b7f67a066c9d2f140e02f57eb27eac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8e07504630aa6eaf6740fc866400bf0"><td class="memItemLeft" align="right" valign="top"><a id="af8e07504630aa6eaf6740fc866400bf0"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#af8e07504630aa6eaf6740fc866400bf0">setFileNamePattern</a> (const std::string &amp;pattern)</td></tr>
<tr class="memdesc:af8e07504630aa6eaf6740fc866400bf0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the file name pattern used in image sequences. <br /></td></tr>
<tr class="separator:af8e07504630aa6eaf6740fc866400bf0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada9ea083b80597e3c2ce3d7ca656408e"><td class="memItemLeft" align="right" valign="top"><a id="ada9ea083b80597e3c2ce3d7ca656408e"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ada9ea083b80597e3c2ce3d7ca656408e">getNumResolutions</a> ()</td></tr>
<tr class="memdesc:ada9ea083b80597e3c2ce3d7ca656408e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of available resolutions in the image. <br /></td></tr>
<tr class="separator:ada9ea083b80597e3c2ce3d7ca656408e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a553c53c71baa7fbb92af53418ae30f8c"><td class="memItemLeft" align="right" valign="top"><a id="a553c53c71baa7fbb92af53418ae30f8c"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a553c53c71baa7fbb92af53418ae30f8c">getNumBitsPerPixel</a> ()</td></tr>
<tr class="memdesc:a553c53c71baa7fbb92af53418ae30f8c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of bits per pixel for this image. <br /></td></tr>
<tr class="separator:a553c53c71baa7fbb92af53418ae30f8c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaca96b84cac352ce920c666fbfae1e12"><td class="memItemLeft" align="right" valign="top"><a id="aaca96b84cac352ce920c666fbfae1e12"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aaca96b84cac352ce920c666fbfae1e12">getNumChannels</a> ()</td></tr>
<tr class="memdesc:aaca96b84cac352ce920c666fbfae1e12"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the number of channels for this image. <br /></td></tr>
<tr class="separator:aaca96b84cac352ce920c666fbfae1e12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73b493b1a07fa387719d027acbf65670"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a73b493b1a07fa387719d027acbf65670">getMinValue</a> (int n=0)</td></tr>
<tr class="memdesc:a73b493b1a07fa387719d027acbf65670"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the minimum sample value for each channel.  <a href="#a73b493b1a07fa387719d027acbf65670">More...</a><br /></td></tr>
<tr class="separator:a73b493b1a07fa387719d027acbf65670"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a429fe94bcece25038c33d55e9046fa12"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a429fe94bcece25038c33d55e9046fa12">getMaxValue</a> (int n=0)</td></tr>
<tr class="memdesc:a429fe94bcece25038c33d55e9046fa12"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the minimum sample value for each channel.  <a href="#a429fe94bcece25038c33d55e9046fa12">More...</a><br /></td></tr>
<tr class="separator:a429fe94bcece25038c33d55e9046fa12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a99f376ced738d34263756fb875e950"><td class="memItemLeft" align="right" valign="top"><a id="a9a99f376ced738d34263756fb875e950"></a>
SampleType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a9a99f376ced738d34263756fb875e950">getSampleType</a> ()</td></tr>
<tr class="memdesc:a9a99f376ced738d34263756fb875e950"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the sample format type. <br /></td></tr>
<tr class="separator:a9a99f376ced738d34263756fb875e950"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a931490883ccce09a45a97a85ebf79561"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a931490883ccce09a45a97a85ebf79561">getImageWidth</a> (int n=0)</td></tr>
<tr class="memdesc:a931490883ccce09a45a97a85ebf79561"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the image width in pixels for a given resolution.  <a href="#a931490883ccce09a45a97a85ebf79561">More...</a><br /></td></tr>
<tr class="separator:a931490883ccce09a45a97a85ebf79561"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acf2e51d0cf8ddf1afca64ff678f2c172"><td class="memItemLeft" align="right" valign="top">unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#acf2e51d0cf8ddf1afca64ff678f2c172">getImageHeight</a> (int n=0)</td></tr>
<tr class="memdesc:acf2e51d0cf8ddf1afca64ff678f2c172"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the image height in pixels for a given resolution.  <a href="#acf2e51d0cf8ddf1afca64ff678f2c172">More...</a><br /></td></tr>
<tr class="separator:acf2e51d0cf8ddf1afca64ff678f2c172"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfd041ac9b341757368cc97750663341"><td class="memItemLeft" align="right" valign="top"><a id="acfd041ac9b341757368cc97750663341"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#acfd041ac9b341757368cc97750663341">getTileHeight</a> ()</td></tr>
<tr class="memdesc:acfd041ac9b341757368cc97750663341"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the base tile height in pixels for a given resolution. <br /></td></tr>
<tr class="separator:acfd041ac9b341757368cc97750663341"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a86f893a5fbc2067bd744f07a0d1731df"><td class="memItemLeft" align="right" valign="top"><a id="a86f893a5fbc2067bd744f07a0d1731df"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a86f893a5fbc2067bd744f07a0d1731df">getTileWidth</a> ()</td></tr>
<tr class="memdesc:a86f893a5fbc2067bd744f07a0d1731df"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the base tile width in pixels. <br /></td></tr>
<tr class="separator:a86f893a5fbc2067bd744f07a0d1731df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a541ecc87687dcfec7f3a5155059d2277"><td class="memItemLeft" align="right" valign="top"><a id="a541ecc87687dcfec7f3a5155059d2277"></a>
ColourSpaces&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a541ecc87687dcfec7f3a5155059d2277">getColourSpace</a> ()</td></tr>
<tr class="memdesc:a541ecc87687dcfec7f3a5155059d2277"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the colour space for this image. <br /></td></tr>
<tr class="separator:a541ecc87687dcfec7f3a5155059d2277"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa81f258d49a0a6db9fd97a81370aba30"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aa81f258d49a0a6db9fd97a81370aba30">getMetadata</a> (const std::string &amp;index)</td></tr>
<tr class="memdesc:aa81f258d49a0a6db9fd97a81370aba30"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return image metadata.  <a href="#aa81f258d49a0a6db9fd97a81370aba30">More...</a><br /></td></tr>
<tr class="separator:aa81f258d49a0a6db9fd97a81370aba30"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a749f7d698473559d31b36e8c2b815d4d"><td class="memItemLeft" align="right" valign="top"><a id="a749f7d698473559d31b36e8c2b815d4d"></a>
virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a749f7d698473559d31b36e8c2b815d4d">regionDecoding</a> ()</td></tr>
<tr class="memdesc:a749f7d698473559d31b36e8c2b815d4d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return whether this image type directly handles region decoding. <br /></td></tr>
<tr class="separator:a749f7d698473559d31b36e8c2b815d4d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5de3329815d2a97edefc07004b3bf72"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aa5de3329815d2a97edefc07004b3bf72">Load</a> (const std::string &amp;module)</td></tr>
<tr class="memdesc:aa5de3329815d2a97edefc07004b3bf72"><td class="mdescLeft">&#160;</td><td class="mdescRight">Load the appropriate codec module for this image type.  <a href="#aa5de3329815d2a97edefc07004b3bf72">More...</a><br /></td></tr>
<tr class="separator:aa5de3329815d2a97edefc07004b3bf72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab3f4126c13c57f3a2aa3ad7615cd3a85"><td class="memItemLeft" align="right" valign="top"><a id="ab3f4126c13c57f3a2aa3ad7615cd3a85"></a>
virtual const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ab3f4126c13c57f3a2aa3ad7615cd3a85">getDescription</a> ()</td></tr>
<tr class="memdesc:ab3f4126c13c57f3a2aa3ad7615cd3a85"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return codec description: Overloaded by child class. <br /></td></tr>
<tr class="separator:ab3f4126c13c57f3a2aa3ad7615cd3a85"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd6a0dc0dbfabe05c52b4cf8ab90032c"><td class="memItemLeft" align="right" valign="top"><a id="abd6a0dc0dbfabe05c52b4cf8ab90032c"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#abd6a0dc0dbfabe05c52b4cf8ab90032c">openImage</a> ()</td></tr>
<tr class="memdesc:abd6a0dc0dbfabe05c52b4cf8ab90032c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Open the image: Overloaded by child class. <br /></td></tr>
<tr class="separator:abd6a0dc0dbfabe05c52b4cf8ab90032c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b1c213f6057facf0b5c2f94ed5240b3"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a6b1c213f6057facf0b5c2f94ed5240b3">loadImageInfo</a> (int x, int y)</td></tr>
<tr class="memdesc:a6b1c213f6057facf0b5c2f94ed5240b3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Load information about the image eg. number of channels, tile size etc.  <a href="#a6b1c213f6057facf0b5c2f94ed5240b3">More...</a><br /></td></tr>
<tr class="separator:a6b1c213f6057facf0b5c2f94ed5240b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa1c4af627d8985bf8d882ffc49d7cc17"><td class="memItemLeft" align="right" valign="top"><a id="aa1c4af627d8985bf8d882ffc49d7cc17"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aa1c4af627d8985bf8d882ffc49d7cc17">closeImage</a> ()</td></tr>
<tr class="memdesc:aa1c4af627d8985bf8d882ffc49d7cc17"><td class="mdescLeft">&#160;</td><td class="mdescRight">Close the image: Overloaded by child class. <br /></td></tr>
<tr class="separator:aa1c4af627d8985bf8d882ffc49d7cc17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae0f3b29ad6016e40a543db581f60f87b"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classRawTile.html">RawTile</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ae0f3b29ad6016e40a543db581f60f87b">getTile</a> (int h, int v, unsigned int r, int l, unsigned int t)</td></tr>
<tr class="memdesc:ae0f3b29ad6016e40a543db581f60f87b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return an individual tile for a given angle and resolution.  <a href="#ae0f3b29ad6016e40a543db581f60f87b">More...</a><br /></td></tr>
<tr class="separator:ae0f3b29ad6016e40a543db581f60f87b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ea39b31b5fee84f16e0487e876f90e9"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classRawTile.html">RawTile</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a4ea39b31b5fee84f16e0487e876f90e9">getRegion</a> (int ha, int va, unsigned int r, int layers, int x, int y, unsigned int w, unsigned int h)</td></tr>
<tr class="memdesc:a4ea39b31b5fee84f16e0487e876f90e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return a region for a given angle and resolution.  <a href="#a4ea39b31b5fee84f16e0487e876f90e9">More...</a><br /></td></tr>
<tr class="separator:a4ea39b31b5fee84f16e0487e876f90e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33361969aaa0f0c8a458859951b79c21"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classIIPImage.html">IIPImage</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a33361969aaa0f0c8a458859951b79c21">operator=</a> (<a class="el" href="classIIPImage.html">IIPImage</a> image)</td></tr>
<tr class="memdesc:a33361969aaa0f0c8a458859951b79c21"><td class="mdescLeft">&#160;</td><td class="mdescRight">Assignment operator.  <a href="#a33361969aaa0f0c8a458859951b79c21">More...</a><br /></td></tr>
<tr class="separator:a33361969aaa0f0c8a458859951b79c21"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a44c428ccf5732f5930897db57b75f63b"><td class="memItemLeft" align="right" valign="top"><a id="a44c428ccf5732f5930897db57b75f63b"></a>
std::vector&lt; unsigned int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a44c428ccf5732f5930897db57b75f63b">image_widths</a></td></tr>
<tr class="memdesc:a44c428ccf5732f5930897db57b75f63b"><td class="mdescLeft">&#160;</td><td class="mdescRight">The image pixel dimensions. <br /></td></tr>
<tr class="separator:a44c428ccf5732f5930897db57b75f63b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6536d47e6fdc7af0a348502c54a6084e"><td class="memItemLeft" align="right" valign="top"><a id="a6536d47e6fdc7af0a348502c54a6084e"></a>
std::vector&lt; unsigned int &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>image_heights</b></td></tr>
<tr class="separator:a6536d47e6fdc7af0a348502c54a6084e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b51c8811c316082af8ac76f8bf71458"><td class="memItemLeft" align="right" valign="top"><a id="a9b51c8811c316082af8ac76f8bf71458"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a9b51c8811c316082af8ac76f8bf71458">tile_width</a></td></tr>
<tr class="memdesc:a9b51c8811c316082af8ac76f8bf71458"><td class="mdescLeft">&#160;</td><td class="mdescRight">The base tile pixel dimensions. <br /></td></tr>
<tr class="separator:a9b51c8811c316082af8ac76f8bf71458"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa1ccfc2c180145fcf80da299ea030375"><td class="memItemLeft" align="right" valign="top"><a id="aa1ccfc2c180145fcf80da299ea030375"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><b>tile_height</b></td></tr>
<tr class="separator:aa1ccfc2c180145fcf80da299ea030375"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abf83b9ff976db63209afe1029934dd61"><td class="memItemLeft" align="right" valign="top"><a id="abf83b9ff976db63209afe1029934dd61"></a>
ColourSpaces&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#abf83b9ff976db63209afe1029934dd61">colourspace</a></td></tr>
<tr class="memdesc:abf83b9ff976db63209afe1029934dd61"><td class="mdescLeft">&#160;</td><td class="mdescRight">The colour space of the image. <br /></td></tr>
<tr class="separator:abf83b9ff976db63209afe1029934dd61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87e6b75dadea8b2835fc798b2c6422f7"><td class="memItemLeft" align="right" valign="top"><a id="a87e6b75dadea8b2835fc798b2c6422f7"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a87e6b75dadea8b2835fc798b2c6422f7">numResolutions</a></td></tr>
<tr class="memdesc:a87e6b75dadea8b2835fc798b2c6422f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of available resolutions in this image. <br /></td></tr>
<tr class="separator:a87e6b75dadea8b2835fc798b2c6422f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff0048158d9083ccb4f4e3b91c1d82f7"><td class="memItemLeft" align="right" valign="top"><a id="aff0048158d9083ccb4f4e3b91c1d82f7"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aff0048158d9083ccb4f4e3b91c1d82f7">bpc</a></td></tr>
<tr class="memdesc:aff0048158d9083ccb4f4e3b91c1d82f7"><td class="mdescLeft">&#160;</td><td class="mdescRight">The bits per channel for this image. <br /></td></tr>
<tr class="separator:aff0048158d9083ccb4f4e3b91c1d82f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afac1d8fe3ba167cfb90a49d437021114"><td class="memItemLeft" align="right" valign="top"><a id="afac1d8fe3ba167cfb90a49d437021114"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#afac1d8fe3ba167cfb90a49d437021114">channels</a></td></tr>
<tr class="memdesc:afac1d8fe3ba167cfb90a49d437021114"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of channels for this image. <br /></td></tr>
<tr class="separator:afac1d8fe3ba167cfb90a49d437021114"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7d66e92f49d1d065edd86f89c186bc7e"><td class="memItemLeft" align="right" valign="top"><a id="a7d66e92f49d1d065edd86f89c186bc7e"></a>
SampleType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a7d66e92f49d1d065edd86f89c186bc7e">sampleType</a></td></tr>
<tr class="memdesc:a7d66e92f49d1d065edd86f89c186bc7e"><td class="mdescLeft">&#160;</td><td class="mdescRight">The sample format type (fixed or floating point) <br /></td></tr>
<tr class="separator:a7d66e92f49d1d065edd86f89c186bc7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a01326e716795bcfa30799c4a3a8dd26f"><td class="memItemLeft" align="right" valign="top"><a id="a01326e716795bcfa30799c4a3a8dd26f"></a>
std::vector&lt; float &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a01326e716795bcfa30799c4a3a8dd26f">min</a></td></tr>
<tr class="memdesc:a01326e716795bcfa30799c4a3a8dd26f"><td class="mdescLeft">&#160;</td><td class="mdescRight">The min and max sample value for each channel. <br /></td></tr>
<tr class="separator:a01326e716795bcfa30799c4a3a8dd26f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3e3c0c27f0ed382fa4cc02af5aa6febd"><td class="memItemLeft" align="right" valign="top"><a id="a3e3c0c27f0ed382fa4cc02af5aa6febd"></a>
std::vector&lt; float &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>max</b></td></tr>
<tr class="separator:a3e3c0c27f0ed382fa4cc02af5aa6febd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa79374528c9480b121a286c1c9f056a2"><td class="memItemLeft" align="right" valign="top"><a id="aa79374528c9480b121a286c1c9f056a2"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#aa79374528c9480b121a286c1c9f056a2">quality_layers</a></td></tr>
<tr class="memdesc:aa79374528c9480b121a286c1c9f056a2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Quality layers. <br /></td></tr>
<tr class="separator:aa79374528c9480b121a286c1c9f056a2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1dde1c87d4659cc987ec30e74164686c"><td class="memItemLeft" align="right" valign="top"><a id="a1dde1c87d4659cc987ec30e74164686c"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a1dde1c87d4659cc987ec30e74164686c">isSet</a></td></tr>
<tr class="memdesc:a1dde1c87d4659cc987ec30e74164686c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Indicate whether we have opened and initialised some parameters for this image. <br /></td></tr>
<tr class="separator:a1dde1c87d4659cc987ec30e74164686c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2b692ba4a6f2a344d8eefcc441dec19"><td class="memItemLeft" align="right" valign="top"><a id="ab2b692ba4a6f2a344d8eefcc441dec19"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ab2b692ba4a6f2a344d8eefcc441dec19">currentX</a></td></tr>
<tr class="memdesc:ab2b692ba4a6f2a344d8eefcc441dec19"><td class="mdescLeft">&#160;</td><td class="mdescRight">If we have an image sequence, the current X and Y position. <br /></td></tr>
<tr class="separator:ab2b692ba4a6f2a344d8eefcc441dec19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27c190f3dc3272bebebfe3e491e22d76"><td class="memItemLeft" align="right" valign="top"><a id="a27c190f3dc3272bebebfe3e491e22d76"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><b>currentY</b></td></tr>
<tr class="separator:a27c190f3dc3272bebebfe3e491e22d76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac173098b421c39783feebdf753cbdf29"><td class="memItemLeft" align="right" valign="top"><a id="ac173098b421c39783feebdf753cbdf29"></a>
std::vector&lt; unsigned int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ac173098b421c39783feebdf753cbdf29">histogram</a></td></tr>
<tr class="memdesc:ac173098b421c39783feebdf753cbdf29"><td class="mdescLeft">&#160;</td><td class="mdescRight">Image histogram. <br /></td></tr>
<tr class="separator:ac173098b421c39783feebdf753cbdf29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a83030b8e4eb6bbcbb4abdb4932a8d531"><td class="memItemLeft" align="right" valign="top"><a id="a83030b8e4eb6bbcbb4abdb4932a8d531"></a>
std::map&lt; const std::string, std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a83030b8e4eb6bbcbb4abdb4932a8d531">metadata</a></td></tr>
<tr class="memdesc:a83030b8e4eb6bbcbb4abdb4932a8d531"><td class="mdescLeft">&#160;</td><td class="mdescRight">STL map to hold string metadata. <br /></td></tr>
<tr class="separator:a83030b8e4eb6bbcbb4abdb4932a8d531"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a575d5f8b1d24937934f1755dacc17fcc"><td class="memItemLeft" align="right" valign="top"><a id="a575d5f8b1d24937934f1755dacc17fcc"></a>
time_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a575d5f8b1d24937934f1755dacc17fcc">timestamp</a></td></tr>
<tr class="memdesc:a575d5f8b1d24937934f1755dacc17fcc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Image modification timestamp. <br /></td></tr>
<tr class="separator:a575d5f8b1d24937934f1755dacc17fcc"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a160a9f35f8bf1bbe25d55df3f74a056f"><td class="memItemLeft" align="right" valign="top"><a id="a160a9f35f8bf1bbe25d55df3f74a056f"></a>
std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a160a9f35f8bf1bbe25d55df3f74a056f">lut</a></td></tr>
<tr class="memdesc:a160a9f35f8bf1bbe25d55df3f74a056f"><td class="mdescLeft">&#160;</td><td class="mdescRight">LUT. <br /></td></tr>
<tr class="separator:a160a9f35f8bf1bbe25d55df3f74a056f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a03b0132269c3aa1db9bfadb2b332265f"><td class="memItemLeft" align="right" valign="top"><a id="a03b0132269c3aa1db9bfadb2b332265f"></a>
unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a03b0132269c3aa1db9bfadb2b332265f">virtual_levels</a></td></tr>
<tr class="memdesc:a03b0132269c3aa1db9bfadb2b332265f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Number of resolution levels that don't physically exist in file. <br /></td></tr>
<tr class="separator:a03b0132269c3aa1db9bfadb2b332265f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2123b0b3e6b6fd7712cd32c17bf82579"><td class="memItemLeft" align="right" valign="top"><a id="a2123b0b3e6b6fd7712cd32c17bf82579"></a>
ImageFormat&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a2123b0b3e6b6fd7712cd32c17bf82579">format</a></td></tr>
<tr class="memdesc:a2123b0b3e6b6fd7712cd32c17bf82579"><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the image format e.g. tif. <br /></td></tr>
<tr class="separator:a2123b0b3e6b6fd7712cd32c17bf82579"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:ab94aff77a9ac0c020051bc79b8a02d22"><td class="memItemLeft" align="right" valign="top"><a id="ab94aff77a9ac0c020051bc79b8a02d22"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#ab94aff77a9ac0c020051bc79b8a02d22">operator==</a> (const <a class="el" href="classIIPImage.html">IIPImage</a> &amp;, const <a class="el" href="classIIPImage.html">IIPImage</a> &amp;)</td></tr>
<tr class="memdesc:ab94aff77a9ac0c020051bc79b8a02d22"><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparison equality operator. <br /></td></tr>
<tr class="separator:ab94aff77a9ac0c020051bc79b8a02d22"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a324822d5531b420b2cab11f611d62c78"><td class="memItemLeft" align="right" valign="top"><a id="a324822d5531b420b2cab11f611d62c78"></a>
int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classIIPImage.html#a324822d5531b420b2cab11f611d62c78">operator!=</a> (const <a class="el" href="classIIPImage.html">IIPImage</a> &amp;, const <a class="el" href="classIIPImage.html">IIPImage</a> &amp;)</td></tr>
<tr class="memdesc:a324822d5531b420b2cab11f611d62c78"><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparison non-equality operator. <br /></td></tr>
<tr class="separator:a324822d5531b420b2cab11f611d62c78"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Main class to handle the pyramidal image source. </p>
<p>Provides functions to open, get various information from an image source and get individual tiles. This class is the base class for specific image file formats such as Tiled Pyramidal TIFF images via <a class="el" href="TPTImage_8h_source.html">TPTImage.h</a> and JPEG2000 via Kakadu.h </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a0b06782b2f2d63ca75e915762356b638"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0b06782b2f2d63ca75e915762356b638">&#9670;&nbsp;</a></span>IIPImage() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">IIPImage::IIPImage </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>s</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Constructer taking the image path as parameter. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">s</td><td>image path </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a315b290529ed48af287008cb88de5d78"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a315b290529ed48af287008cb88de5d78">&#9670;&nbsp;</a></span>IIPImage() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">IIPImage::IIPImage </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classIIPImage.html">IIPImage</a> &amp;&#160;</td>
          <td class="paramname"><em>image</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Copy Constructor taking reference to another <a class="el" href="classIIPImage.html" title="Main class to handle the pyramidal image source. ">IIPImage</a> object. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">image</td><td><a class="el" href="classIIPImage.html" title="Main class to handle the pyramidal image source. ">IIPImage</a> object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a1c1eed40617116d2886772708db5cd18"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1c1eed40617116d2886772708db5cd18">&#9670;&nbsp;</a></span>getFileName()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string IIPImage::getFileName </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>y</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Return the full file path for a particular horizontal and vertical angle. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>horizontal sequence angle </td></tr>
    <tr><td class="paramname">y</td><td>vertical sequence angle </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="acf2e51d0cf8ddf1afca64ff678f2c172"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acf2e51d0cf8ddf1afca64ff678f2c172">&#9670;&nbsp;</a></span>getImageHeight()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int IIPImage::getImageHeight </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em> = <code>0</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the image height in pixels for a given resolution. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">n</td><td>resolution number (0 is default and full size image) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a931490883ccce09a45a97a85ebf79561"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a931490883ccce09a45a97a85ebf79561">&#9670;&nbsp;</a></span>getImageWidth()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned int IIPImage::getImageWidth </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em> = <code>0</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the image width in pixels for a given resolution. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">n</td><td>resolution number (0 is default and full size image) </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">References <a class="el" href="classIIPImage.html#a44c428ccf5732f5930897db57b75f63b">image_widths</a>.</p>

</div>
</div>
<a id="a429fe94bcece25038c33d55e9046fa12"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a429fe94bcece25038c33d55e9046fa12">&#9670;&nbsp;</a></span>getMaxValue()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">float IIPImage::getMaxValue </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em> = <code>0</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the minimum sample value for each channel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">n</td><td>channel index </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aa81f258d49a0a6db9fd97a81370aba30"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa81f258d49a0a6db9fd97a81370aba30">&#9670;&nbsp;</a></span>getMetadata()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string&amp; IIPImage::getMetadata </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return image metadata. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>metadata field name </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">References <a class="el" href="classIIPImage.html#a83030b8e4eb6bbcbb4abdb4932a8d531">metadata</a>.</p>

</div>
</div>
<a id="a73b493b1a07fa387719d027acbf65670"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a73b493b1a07fa387719d027acbf65670">&#9670;&nbsp;</a></span>getMinValue()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">float IIPImage::getMinValue </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em> = <code>0</code></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return the minimum sample value for each channel. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">n</td><td>channel index </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">References <a class="el" href="classIIPImage.html#a01326e716795bcfa30799c4a3a8dd26f">min</a>.</p>

</div>
</div>
<a id="a4ea39b31b5fee84f16e0487e876f90e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4ea39b31b5fee84f16e0487e876f90e9">&#9670;&nbsp;</a></span>getRegion()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classRawTile.html">RawTile</a> IIPImage::getRegion </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ha</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>va</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>layers</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>w</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>h</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return a region for a given angle and resolution. </p>
<p>Return a <a class="el" href="classRawTile.html" title="Class to represent a single image tile. ">RawTile</a> object: Overloaded by child class. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ha</td><td>horizontal angle </td></tr>
    <tr><td class="paramname">va</td><td>vertical angle </td></tr>
    <tr><td class="paramname">r</td><td>resolution </td></tr>
    <tr><td class="paramname">layers</td><td>number of layers to decode </td></tr>
    <tr><td class="paramname">x</td><td>offset in x direction </td></tr>
    <tr><td class="paramname">y</td><td>offset in y direction </td></tr>
    <tr><td class="paramname">w</td><td>width of region </td></tr>
    <tr><td class="paramname">h</td><td>height of region </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><a class="el" href="classRawTile.html" title="Class to represent a single image tile. ">RawTile</a> image </dd></dl>

<p>Reimplemented in <a class="el" href="classKakaduImage.html#afc9a84e1ce8c302ca96572ebc5f5c456">KakaduImage</a>, and <a class="el" href="classOpenJPEGImage.html#a6bc2f74edbb15f34214288832ca4fd78">OpenJPEGImage</a>.</p>

</div>
</div>
<a id="ae0f3b29ad6016e40a543db581f60f87b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae0f3b29ad6016e40a543db581f60f87b">&#9670;&nbsp;</a></span>getTile()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classRawTile.html">RawTile</a> IIPImage::getTile </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>h</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>v</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>l</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned int&#160;</td>
          <td class="paramname"><em>t</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Return an individual tile for a given angle and resolution. </p>
<p>Return a <a class="el" href="classRawTile.html" title="Class to represent a single image tile. ">RawTile</a> object: Overloaded by child class. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">h</td><td>horizontal angle </td></tr>
    <tr><td class="paramname">v</td><td>vertical angle </td></tr>
    <tr><td class="paramname">r</td><td>resolution </td></tr>
    <tr><td class="paramname">l</td><td>quality layers </td></tr>
    <tr><td class="paramname">t</td><td>tile number </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classKakaduImage.html#aafb16ba604d6d20b3cf6339451e3ede2">KakaduImage</a>, <a class="el" href="classOpenJPEGImage.html#a3c7ba5b04ed3b721a8fd96c702be8632">OpenJPEGImage</a>, and <a class="el" href="classTPTImage.html#a475f61c355abbeaf4a234c61f6d88ace">TPTImage</a>.</p>

</div>
</div>
<a id="aa5de3329815d2a97edefc07004b3bf72"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5de3329815d2a97edefc07004b3bf72">&#9670;&nbsp;</a></span>Load()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void IIPImage::Load </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>module</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Load the appropriate codec module for this image type. </p>
<p>Used only for dynamically loading codec modules. Overloaded by DSOImage class. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">module</td><td>the codec module path </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a6b1c213f6057facf0b5c2f94ed5240b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6b1c213f6057facf0b5c2f94ed5240b3">&#9670;&nbsp;</a></span>loadImageInfo()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void IIPImage::loadImageInfo </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>y</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Load information about the image eg. number of channels, tile size etc. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td>horizontal sequence angle </td></tr>
    <tr><td class="paramname">y</td><td>vertical sequence angle </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented in <a class="el" href="classKakaduImage.html#a9ad91aef16d4079bc0e47d9aa658299f">KakaduImage</a>, <a class="el" href="classOpenJPEGImage.html#a2dcb234ef782b6d21f971a5656a70137">OpenJPEGImage</a>, and <a class="el" href="classTPTImage.html#a0b4a82bb950818c1196377a8ee32930d">TPTImage</a>.</p>

</div>
</div>
<a id="a33361969aaa0f0c8a458859951b79c21"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a33361969aaa0f0c8a458859951b79c21">&#9670;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classIIPImage.html">IIPImage</a>&amp; IIPImage::operator= </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classIIPImage.html">IIPImage</a>&#160;</td>
          <td class="paramname"><em>image</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Assignment operator. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">image</td><td><a class="el" href="classIIPImage.html" title="Main class to handle the pyramidal image source. ">IIPImage</a> object </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">References <a class="el" href="classIIPImage.html#a1ad4382ddbf025261049257bcfbf0f23">swap()</a>.</p>

<p class="reference">Referenced by <a class="el" href="classTPTImage.html#ab0c4ba59e103f9a5464d14a64447031d">TPTImage::operator=()</a>, and <a class="el" href="classKakaduImage.html#afb22dcbefd4567a45c5128f748831926">KakaduImage::operator=()</a>.</p>

</div>
</div>
<a id="a1ad4382ddbf025261049257bcfbf0f23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1ad4382ddbf025261049257bcfbf0f23">&#9670;&nbsp;</a></span>swap()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IIPImage::swap </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classIIPImage.html">IIPImage</a> &amp;&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classIIPImage.html">IIPImage</a> &amp;&#160;</td>
          <td class="paramname"><em>b</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Swap function. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>Object to copy to </td></tr>
    <tr><td class="paramname">b</td><td>Object to copy from </td></tr>
  </table>
  </dd>
</dl>

<p class="reference">Referenced by <a class="el" href="classIIPImage.html#a33361969aaa0f0c8a458859951b79c21">operator=()</a>.</p>

</div>
</div>
<a id="a36b0f425868ddbceb401e046fd8d44e3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a36b0f425868ddbceb401e046fd8d44e3">&#9670;&nbsp;</a></span>updateTimestamp()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IIPImage::updateTimestamp </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>s</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get the image timestamp. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">s</td><td>file path </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="IIPImage_8h_source.html">IIPImage.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classIIPImage.html">IIPImage</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.14 </li>
  </ul>
</div>
</body>
</html>
